variables:
  # AWS CLI Config
  AWS_DEFAULT_REGION: "eu-central-1"
  AWS_REGION: "eu-central-1"
  AWS_ACCOUNT: "473540118483"
  S3_BUCKET: "473540118483.bobo.nil.default.sources"
  S3_KEY: "Bobo.war"
  # Docker Config
  DOCKER_SERVER: seec-serviceteam-1-docker-prod-local.bahnhub.tech.rz.db.de
  DOCKER_REPO: tomcat
  BASE_IMAGE: 'bobo'
  PROXY_SERVER: "http://webproxy.comp.db.de:8080"
  NO_PROXY: "127.0.0.1,169.254.169.254,169.254.170.2,/var/run/weave/weave.sock,/var/run/docker.sock,localhost,private,int-app.db.de,aws.db.de,rz.db.de,comp.db.de,ose.db.de,dbcs.db.de,signintra.com,intranet.deutschebahn.com,intranet-test.deutschebahn.com,intranet.dbschenker.com,service.deutschebahn.com,dbplanet.deutschebahn.com,amazonaws.com,amazon.com"
  BUILD_ARGS: "--build-arg no_proxy=${NO_PROXY} --build-arg NO_PROXY=${NO_PROXY} --build-arg HTTP_PROXY=${PROXY_SERVER} --build-arg HTTPS_PROXY=${PROXY_SERVER} --build-arg http_proxy=${PROXY_SERVER} --build-arg https_proxy=${PROXY_SERVER}"

stages:
  - download
  - build
  - copy
  - scan
  - trigger

downlaod_war:
  stage: download
  image: seec-serviceteam-1-docker-prod-local.bahnhub.tech.rz.db.de/ruby/2.7-alpine:latest
  script:
    # - aws s3 cp s3://473540118483.bobo.nil.default.sources/Bobo.war $CI_PROJECT_DIR/default/$S3_Key --debug
    - aws s3 cp "s3://$S3_BUCKET/$S3_KEY" $CI_PROJECT_DIR/default/
    - ls $CI_PROJECT_DIR/default/
  tags:
    - 'sizit.iat.sizithc.cirunner'
  artifacts:
    name: "$CI_JOB_NAME"
    paths:
      - default/*.war

tomcat:
  stage: build
  image:
    name: seec-serviceteam-1-docker-prod-local.bahnhub.tech.rz.db.de/free4all/go2ecr:2767110 
  script:
    - go2ecr auth --repository $DOCKER_SERVER --user $ARTIFACTORY_USER --password $ARTIFACTORY_PASS
    - executor $BUILD_ARGS --context $CI_PROJECT_DIR/default --dockerfile $CI_PROJECT_DIR/default/Dockerfile --destination "$DOCKER_SERVER/$DOCKER_REPO/$BASE_IMAGE:$CI_COMMIT_BRANCH" --destination "$DOCKER_SERVER/$DOCKER_REPO/$BASE_IMAGE:0.0.$CI_PIPELINE_IID"
  tags:
    - 'sizit.iat.sizithc.cirunner'
  dependencies:
    - downlaod_war

.copy_image:
  stage: copy
  image: seec-serviceteam-1-docker-prod-local.bahnhub.tech.rz.db.de/free4all/go2ecr:2741268
  script:
    - |
      echo -e "section_start:`date +%s`:section_debug\r\e[0KDebug Information"
      echo "----------------------------------------------------------------"
      echo "IMAGE: ${DOCKER_SERVER}/${DOCKER_REPO}/${BASE_IMAGE}:0.0.${CI_PIPELINE_IID}"
      echo "----------------------------------------------------------------"
      echo -e "section_end:`date +%s`:section_debug\r\e[0K"

    - |
      echo -e "section_start:`date +%s`:section_copy\r\e[0KCopy Image"
      echo "----------------------------------------------------------------"
      go2ecr ecr uploadImage --image "${DOCKER_SERVER}/${DOCKER_REPO}/${BASE_IMAGE}:0.0.${CI_PIPELINE_IID}" --create-repository
      crane tag "$ACCOUNT.dkr.ecr.eu-central-1.amazonaws.com/${DOCKER_SERVER}/${DOCKER_REPO}/${BASE_IMAGE}:0.0.${CI_PIPELINE_IID}" $CI_COMMIT_BRANCH
      echo "----------------------------------------------------------------"
      echo -e "section_end:`date +%s`:section_copy\r\e[0K"

copy_image_iat:
  variables:
    ACCOUNT: "473540118483"
  extends:
    - .copy_image
  tags:
    - sizit.iat.sizithc.cirunner

copy_image_prd:
  variables:
    ACCOUNT: "938000474587"
  extends:
    - .copy_image
  tags:
    - sizit.prd.sizithc.cirunner

scan_image:
  stage: scan
  image: seec-serviceteam-1-docker-prod-local.bahnhub.tech.rz.db.de/free4all/go2ecr:2741268
  script:
    - go2ecr ecr scanImage --image "${DOCKER_SERVER}/${DOCKER_REPO}/${BASE_IMAGE}:0.0.${CI_PIPELINE_IID}" --scanresult-template /go2ecr/jUnit.xml --scanresult-output result.xml
  tags:
    - sizit.iat.sizithc.cirunner
  rules:
    - when: on_success
      allow_failure: true
  artifacts:
    paths:
      - result.xml
    reports:
      junit: result.xml

trigger_deployment_iat:
  stage: trigger
  script:
    - curl -X POST -F token=$TOKEN -F ref=iat -F variables[IMAGE]="${DOCKER_SERVER}/${DOCKER_REPO}/${BASE_IMAGE}:0.0.${CI_PIPELINE_IID}" https://git.tech.rz.db.de/api/v4/projects/44508/trigger/pipeline
  rules:
    - if: $CI_COMMIT_BRANCH == "latest"
  tags:
    - sizit.iat.sizithc.cirunner
